{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v2"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"iam.PermissionsGroup":{"type":"object","description":"Permissions group defines a re-usable set of permissions","properties":{"createdAt":{"type":"string","description":"Creation time","format":"date-time","readOnly":true},"description":{"type":"string","description":"Description of the permissions group"},"id":{"type":"string","description":"Identifier of the permissions group","format":"uuid","readOnly":true},"name":{"type":"string","description":"Name of the permissions group"},"owner":{"type":"string","description":"Owner of the permissions group","readOnly":true},"permissions":{"allOf":[{"$ref":"#/components/schemas/iam.policy.Permissions"}],"description":"Permissions granted when using this permissions group"},"updatedAt":{"type":"string","description":"Last update time","nullable":true,"format":"date-time","readOnly":true},"urn":{"type":"string","description":"Unique resource name used in policies to include this permissions group","readOnly":true}},"required":["description","name","permissions"]},"iam.policy.Action":{"type":"object","description":"Action that can be allowed or denied on a resource","properties":{"action":{"type":"string","description":"Name of the action"}},"required":["action"]},"iam.policy.Permissions":{"type":"object","description":"Permissions included in a policy","properties":{"allow":{"type":"array","description":"List of allowed actions","nullable":true,"items":{"$ref":"#/components/schemas/iam.policy.Action"}},"deny":{"type":"array","description":"Actions to deny the access to","nullable":true,"items":{"$ref":"#/components/schemas/iam.policy.Action"}},"except":{"type":"array","description":"Actions to filter from the allowed list","nullable":true,"items":{"$ref":"#/components/schemas/iam.policy.Action"}}}},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/iam/permissionsGroup":{"get":{"operationId":"getAllIamPermissionsGroups","summary":"List permissions groups","description":"Returns the permissions groups of the account, and the platform (`ovh`) groups reusable in policies.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"header","name":"X-Pagination-Cursor","description":"Pagination cursor","schema":{"type":"string"}},{"in":"header","name":"X-Pagination-Size","description":"Pagination size","schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/iam.PermissionsGroup"}},"examples":{"Get permissions groups":{"value":[{"createdAt":"2023-05-12T13:38:15.73892Z","description":"Set of actions required to manage vrack products","id":"6956639e-3848-11ee-ae3c-0050568ce122","name":"vrackManagement","owner":"ovh","permissions":{"allow":[{"action":"*:vrack:*"}]},"updatedAt":"2023-06-19T13:13:34.642173Z","urn":"urn:v1:eu:permissionsGroup:ovh:vrackManagement"}],"summary":"Response body returned when listing permissions groups"}}}}}},"tags":["Permissions & policies"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Permissions Groups@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/iam/permissionsGroup\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/iam/permissionsGroup\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/permissionsGroup/get","required":true}],"x-response-identifier":"urn","x-expanded-response":"IamPermissionsGroup"},"post":{"operationId":"createIamPermissionsGroup","summary":"Create a permissions group","description":"Creates a reusable allow/deny action set to attach to policies via `permissionsGroups`.","security":[{"oAuth2AuthCode":[]}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.PermissionsGroup"},"examples":{"Create a permissions group":{"value":{"description":"My custom permissions group","name":"myPermissions","permissions":{"allow":[{"action":"*:apiovh:*"}]}},"summary":"Request body used when creating a permissions group"}}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.PermissionsGroup"},"examples":{"Get a permissions group":{"value":{"createdAt":"2023-05-12T13:38:15.73892Z","description":"My custom permissions group","id":"6956639e-3848-11ee-ae3c-0050568ce122","name":"myPermissions","owner":"aa1-ovh","permissions":{"allow":[{"action":"*:apiovh:*"}]},"updatedAt":"2023-06-19T13:13:34.642173Z","urn":"urn:v1:eu:permissionsGroup:aa1-ovh:myPermissions"},"summary":"Response body returned when creating a permissions group"}}}}}},"tags":["Permissions & policies"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Permissions Groups@@@30"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: iam.PermissionsGroup\nresult = client.post(\"/v2/iam/permissionsGroup\",\n\tdescription = None, # Description of the permissions group (type: string)\n\tname = None, # Name of the permissions group (type: string)\n\tpermissions = None, # Permissions granted when using this permissions group (type: iam.policy.Permissions)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: iam.PermissionsGroup\n$result = $ovh->post(\"/v2/iam/permissionsGroup\", array(\n\tdescription => null, // Description of the permissions group (type: string)\n\tname => null, // Name of the permissions group (type: string)\n\tpermissions => null, // Permissions granted when using this permissions group (type: iam.policy.Permissions)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/permissionsGroup/create","required":true}]}},"/iam/permissionsGroup/{permissionsGroupURN}":{"delete":{"operationId":"deleteIamPermissionsGroup","summary":"Delete a permissions group","description":"Deletes the permissions group. Resources and policies linked to it are not affected.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"permissionsGroupURN","description":"Permissions groupurn","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"successful operation"}},"tags":["Permissions & policies"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Permissions Groups@@@40"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.delete(\"/v2/iam/permissionsGroup/{permissionsGroupURN}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->delete(\"/v2/iam/permissionsGroup/{permissionsGroupURN}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/permissionsGroup/delete","required":true}]},"get":{"operationId":"getIamPermissionsGroup","summary":"Get a permissions group","description":"Returns the name, description and permissions of the group.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"permissionsGroupURN","description":"Permissions groupurn","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.PermissionsGroup"},"examples":{"Get a permissions group":{"value":{"createdAt":"2023-05-12T13:38:15.73892Z","description":"Set of actions required to manage vrack products","id":"6956639e-3848-11ee-ae3c-0050568ce122","name":"vrackManagement","owner":"ovh","permissions":{"allow":[{"action":"*:vrack:*"}]},"updatedAt":"2023-06-19T13:13:34.642173Z","urn":"urn:v1:eu:permissionsGroup:ovh:vrackManagement"},"summary":"Response body returned when getting a permissions group"}}}}}},"tags":["Permissions & policies"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Permissions Groups@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/iam/permissionsGroup/{permissionsGroupURN}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/iam/permissionsGroup/{permissionsGroupURN}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/permissionsGroup/get","required":true}],"x-response-identifier":"urn"},"put":{"operationId":"editIamPermissionsGroup","summary":"Update a permissions group","description":"Replaces the group's name, description and permissions.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"permissionsGroupURN","description":"Permissions groupurn","required":true,"schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.PermissionsGroup"},"examples":{"Update a permissions group":{"value":{"description":"My custom permissions group","name":"myPermissions","permissions":{"allow":[{"action":"*:apiovh:*"}]}},"summary":"Request body used when updating a permissions group"}}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.PermissionsGroup"},"examples":{"Update a permissions group":{"value":{"createdAt":"2023-05-12T13:38:15.73892Z","description":"My custom permissions group","id":"6956639e-3848-11ee-ae3c-0050568ce122","name":"myPermissions","owner":"aa1-ovh","permissions":{"allow":[{"action":"*:apiovh:*"}]},"updatedAt":"2023-06-19T13:13:34.642173Z","urn":"urn:v1:eu:permissionsGroup:aa1-ovh:myPermissions"},"summary":"Response body returned when updating a permissions group"}}}}}},"tags":["Permissions & policies"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Permissions Groups@@@50"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: iam.PermissionsGroup\nresult = client.put(\"/v2/iam/permissionsGroup/{permissionsGroupURN}\",\n\tdescription = None, # Description of the permissions group (type: string)\n\tname = None, # Name of the permissions group (type: string)\n\tpermissions = None, # Permissions granted when using this permissions group (type: iam.policy.Permissions)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: iam.PermissionsGroup\n$result = $ovh->put(\"/v2/iam/permissionsGroup/{permissionsGroupURN}\", array(\n\tdescription => null, // Description of the permissions group (type: string)\n\tname => null, // Name of the permissions group (type: string)\n\tpermissions => null, // Permissions granted when using this permissions group (type: iam.policy.Permissions)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/permissionsGroup/edit","required":true}]}}},"tags":[{"name":"Permissions & policies","x-tag-expanded":false,"description":"Missing description"}]}
